diff --git a/web/regression/python_test_utils/test_utils.py b/web/regression/python_test_utils/test_utils.py
index f94c20ab0..e93f2d3d8 100644
--- a/web/regression/python_test_utils/test_utils.py
+++ b/web/regression/python_test_utils/test_utils.py
@@ -12,7 +12,6 @@ import traceback
 import os
 import sys
 import uuid
-import psycopg2
 import sqlite3
 import shutil
 from functools import partial
@@ -41,6 +40,8 @@ from pgadmin.utils import set_binary_path
 
 from functools import wraps
 
+import psycopg
+
 CURRENT_PATH = os.path.abspath(os.path.join(os.path.dirname(
     os.path.realpath(__file__)), "../"))
 
@@ -51,8 +52,8 @@ file_name = os.path.realpath(__file__)
 
 def get_db_connection(db, username, password, host, port, sslmode="prefer"):
     """This function returns the connection object of psycopg"""
-    connection = psycopg2.connect(
-        database=db,
+    connection = psycopg.connect(
+        dbname=db,
         user=username,
         password=password,
         host=host,
@@ -62,6 +63,19 @@ def get_db_connection(db, username, password, host, port, sslmode="prefer"):
     return connection
 
 
+def get_server_version(connection):
+    return connection.info.server_version
+
+
+def set_isolation_level(connection, level):
+    if level == 0:
+        connection.rollback()
+        connection.autocommit = True
+    else:
+        connection.autocommit = False
+        connection.isolation_level = level
+
+
 def login_tester_account(tester):
     """
     This function login the test client using env variables email and password
@@ -141,7 +155,8 @@ def create_database(server, db_name, encoding=None):
             server['sslmode']
         )
         old_isolation_level = connection.isolation_level
-        connection.set_isolation_level(0)
+        set_isolation_level(connection, 0)
+        connection.autocommit = True
         pg_cursor = connection.cursor()
         if encoding is None:
             pg_cursor.execute(
@@ -151,7 +166,8 @@ def create_database(server, db_name, encoding=None):
                 '''CREATE DATABASE "%s" TEMPLATE template0
                 ENCODING='%s' LC_COLLATE='%s' LC_CTYPE='%s' ''' %
                 (db_name, encoding[0], encoding[1], encoding[1]))
-        connection.set_isolation_level(old_isolation_level)
+        connection.autocommit = False
+        set_isolation_level(connection, old_isolation_level)
         connection.commit()
 
         # Get 'oid' from newly created database
@@ -188,7 +204,7 @@ def create_table(server, db_name, table_name, extra_columns=[]):
             server['sslmode']
         )
         old_isolation_level = connection.isolation_level
-        connection.set_isolation_level(0)
+        set_isolation_level(connection, 0)
 
         extra_columns_sql = ", " + ", ".join(extra_columns) \
             if len(extra_columns) > 0 else ''
@@ -210,7 +226,7 @@ def create_table(server, db_name, table_name, extra_columns=[]):
             VALUES ('Yet-Another-Name', 14,
             'cool info')''' % table_name)
 
-        connection.set_isolation_level(old_isolation_level)
+        set_isolation_level(connection, old_isolation_level)
         connection.commit()
 
     except Exception:
@@ -267,10 +283,10 @@ def create_table_with_query(server, db_name, query):
             server['sslmode']
         )
         old_isolation_level = connection.isolation_level
-        connection.set_isolation_level(0)
+        set_isolation_level(connection, 0)
         pg_cursor = connection.cursor()
         pg_cursor.execute(query)
-        connection.set_isolation_level(old_isolation_level)
+        set_isolation_level(connection, old_isolation_level)
         connection.commit()
 
     except Exception:
@@ -292,14 +308,14 @@ def create_constraint(server,
             server['sslmode']
         )
         old_isolation_level = connection.isolation_level
-        connection.set_isolation_level(0)
+        set_isolation_level(connection, 0)
         pg_cursor = connection.cursor()
         pg_cursor.execute('''
             ALTER TABLE "%s"
               ADD CONSTRAINT "%s" %s (some_column)
             ''' % (table_name, constraint_name, constraint_type.upper()))
 
-        connection.set_isolation_level(old_isolation_level)
+        set_isolation_level(connection, old_isolation_level)
         connection.commit()
 
     except Exception:
@@ -329,7 +345,7 @@ def create_type(server, db_name, type_name, type_fields=[]):
             server['sslmode']
         )
         old_isolation_level = connection.isolation_level
-        connection.set_isolation_level(0)
+        set_isolation_level(connection, 0)
 
         type_fields_sql = ", ".join(type_fields)
 
@@ -337,7 +353,7 @@ def create_type(server, db_name, type_name, type_fields=[]):
         pg_cursor.execute(
             '''CREATE TYPE %s AS (%s)''' % (type_name, type_fields_sql))
 
-        connection.set_isolation_level(old_isolation_level)
+        set_isolation_level(connection, old_isolation_level)
         connection.commit()
 
     except Exception:
@@ -355,7 +371,7 @@ def create_debug_function(server, db_name, function_name="test_func"):
             server['sslmode']
         )
         old_isolation_level = connection.isolation_level
-        connection.set_isolation_level(0)
+        set_isolation_level(connection, 0)
         pg_cursor = connection.cursor()
         try:
             pg_cursor.execute('''CREATE EXTENSION pldbgapi;''')
@@ -376,7 +392,7 @@ def create_debug_function(server, db_name, function_name="test_func"):
               END;
             $function$;
             ''' % function_name)
-        connection.set_isolation_level(old_isolation_level)
+        set_isolation_level(connection, old_isolation_level)
         connection.commit()
 
     except Exception:
@@ -394,12 +410,12 @@ def drop_debug_function(server, db_name, function_name="test_func"):
             server['sslmode']
         )
         old_isolation_level = connection.isolation_level
-        connection.set_isolation_level(0)
+        set_isolation_level(connection, 0)
         pg_cursor = connection.cursor()
         pg_cursor.execute('''
             DROP FUNCTION public."%s"();
             ''' % function_name)
-        connection.set_isolation_level(old_isolation_level)
+        set_isolation_level(connection, old_isolation_level)
         connection.commit()
 
     except Exception:
@@ -438,14 +454,14 @@ def grant_role(server, db_name, role_name="test_role",
             server['sslmode']
         )
         old_isolation_level = connection.isolation_level
-        connection.set_isolation_level(0)
+        set_isolation_level(connection, 0)
         pg_cursor = connection.cursor()
         sql_query = '''GRANT "%s" TO %s;''' % (grant_role, role_name)
 
         pg_cursor.execute(
             sql_query
         )
-        connection.set_isolation_level(old_isolation_level)
+        set_isolation_level(connection, old_isolation_level)
         connection.commit()
 
     except Exception:
@@ -463,7 +479,7 @@ def create_role(server, db_name, role_name="test_role"):
             server['sslmode']
         )
         old_isolation_level = connection.isolation_level
-        connection.set_isolation_level(0)
+        set_isolation_level(connection, 0)
         pg_cursor = connection.cursor()
         sql_query = '''
             CREATE USER "%s" WITH
@@ -473,13 +489,13 @@ def create_role(server, db_name, role_name="test_role"):
               CREATEDB
               NOCREATEROLE
             ''' % (role_name)
-        if connection.server_version > 90100:
+        if get_server_version(connection) > 90100:
             sql_query += '\nNOREPLICATION'
 
         pg_cursor.execute(
             sql_query
         )
-        connection.set_isolation_level(old_isolation_level)
+        set_isolation_level(connection, old_isolation_level)
         connection.commit()
 
     except Exception:
@@ -497,12 +513,12 @@ def drop_role(server, db_name, role_name="test_role"):
             server['sslmode']
         )
         old_isolation_level = connection.isolation_level
-        connection.set_isolation_level(0)
+        set_isolation_level(connection, 0)
         pg_cursor = connection.cursor()
         pg_cursor.execute('''
             DROP USER "%s"
             ''' % role_name)
-        connection.set_isolation_level(old_isolation_level)
+        set_isolation_level(connection, old_isolation_level)
         connection.commit()
 
     except Exception:
@@ -513,7 +529,7 @@ def drop_database(connection, database_name):
     """This function used to drop the database"""
     if database_name not in ["postgres", "template1", "template0"]:
         pg_cursor = connection.cursor()
-        if connection.server_version >= 90100:
+        if connection.info.server_version >= 90100:
             pg_cursor.execute(
                 "SELECT pg_terminate_backend(pg_stat_activity.pid) "
                 "FROM pg_stat_activity "
@@ -531,9 +547,9 @@ def drop_database(connection, database_name):
                           " db.datname='%s'" % database_name)
         if pg_cursor.fetchall():
             old_isolation_level = connection.isolation_level
-            connection.set_isolation_level(0)
+            set_isolation_level(connection, 0)
             pg_cursor.execute('''DROP DATABASE "%s"''' % database_name)
-            connection.set_isolation_level(old_isolation_level)
+            set_isolation_level(connection, old_isolation_level)
             connection.commit()
             connection.close()
 
@@ -543,7 +559,7 @@ def drop_database_multiple(connection, database_names):
     for database_name in database_names:
         if database_name not in ["postgres", "template1", "template0"]:
             pg_cursor = connection.cursor()
-            if connection.server_version >= 90100:
+            if test_utils.get_server_version(connection) >= 90100:
                 pg_cursor.execute(
                     "SELECT pg_terminate_backend(pg_stat_activity.pid) "
                     "FROM pg_stat_activity "
@@ -561,9 +577,9 @@ def drop_database_multiple(connection, database_names):
                               " db.datname='%s'" % database_name)
             if pg_cursor.fetchall():
                 old_isolation_level = connection.isolation_level
-                connection.set_isolation_level(0)
+                set_isolation_level(connection, 0)
                 pg_cursor.execute('''DROP DATABASE "%s"''' % database_name)
-                connection.set_isolation_level(old_isolation_level)
+                set_isolation_level(connection, old_isolation_level)
                 connection.commit()
     connection.close()
 
@@ -577,9 +593,9 @@ def drop_tablespace(connection):
         for table_space in table_spaces:
             if table_space[0] not in ["pg_default", "pg_global"]:
                 old_isolation_level = connection.isolation_level
-                connection.set_isolation_level(0)
+                set_isolation_level(connection, 0)
                 pg_cursor.execute("DROP TABLESPACE %s" % table_space[0])
-                connection.set_isolation_level(old_isolation_level)
+                set_isolation_level(connection, old_isolation_level)
                 connection.commit()
     connection.close()
 
@@ -1121,11 +1137,11 @@ def create_schema(server, db_name, schema_name):
             server['sslmode']
         )
         old_isolation_level = connection.isolation_level
-        connection.set_isolation_level(0)
+        set_isolation_level(connection, 0)
         pg_cursor = connection.cursor()
         pg_cursor.execute(
             '''CREATE SCHEMA "%s"''' % schema_name)
-        connection.set_isolation_level(old_isolation_level)
+        set_isolation_level(connection, old_isolation_level)
         connection.commit()
 
     except Exception:
@@ -1186,7 +1202,7 @@ def check_binary_path_or_skip_test(cls, utility_name):
 
 
 def get_driver_version():
-    version = getattr(psycopg2, '__version__', None)
+    version = getattr(psycopg, '__version__', None)
     return version
 
 
diff --git a/web/regression/re_sql/tests/test_resql.py b/web/regression/re_sql/tests/test_resql.py
index cc3dd1474..8b4d3db7b 100644
--- a/web/regression/re_sql/tests/test_resql.py
+++ b/web/regression/re_sql/tests/test_resql.py
@@ -272,6 +272,10 @@ class ReverseEngineeredSQLTestCases(BaseTestGenerator):
                 try:
                     self.assertEqual(response.status_code, 200)
                 except Exception as e:
+                    response = self.tester.post(create_url,
+                                                data=json.dumps(
+                                                    scenario['data']),
+                                                content_type='html/json')
                     self.final_test_status = False
                     print(scenario['name'] + "... FAIL")
                     traceback.print_exc()
@@ -307,6 +311,11 @@ class ReverseEngineeredSQLTestCases(BaseTestGenerator):
                     self.assertEqual(response.status_code, 200)
                 except Exception as e:
                     self.final_test_status = False
+                    alter_url = self.get_url(scenario['endpoint'], object_id)
+                    response = self.tester.put(alter_url,
+                                               data=json.dumps(
+                                                   scenario['data']),
+                                               follow_redirects=True)
                     print(scenario['name'] + "... FAIL")
                     traceback.print_exc()
                     continue
@@ -495,7 +504,6 @@ class ReverseEngineeredSQLTestCases(BaseTestGenerator):
         try:
             self.assertEqual(response.status_code, 200)
         except Exception as e:
-
             self.final_test_status = False
             traceback.print_exc()
             return False
@@ -524,6 +532,8 @@ class ReverseEngineeredSQLTestCases(BaseTestGenerator):
                 try:
                     self.assertEqual(sql, resp_sql)
                 except Exception as e:
+                    print(sql)
+                    print(resp_sql)
                     self.final_test_status = False
                     traceback.print_exc()
                     return False
diff --git a/web/regression/runtests.py b/web/regression/runtests.py
index a008c3119..80646b48e 100644
--- a/web/regression/runtests.py
+++ b/web/regression/runtests.py
@@ -489,7 +489,7 @@ def execute_test(test_module_list_passed, server_passed, driver_passed,
         )
 
         # Add the server version in server information
-        server_information['server_version'] = connection.server_version
+        server_information['server_version'] = connection.info.server_version
         server_information['type'] = server_passed['type']
 
         # Drop the database if already exists.
